/* Copyright (c) 2001-2005 Todd C. Stellanova, rawthought
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The  above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE. 
 * 
 * 
 * 
 * */

package org.kablog.kdb;



/**
 * Special exception class for handling DB problems
 *
 * @author Todd c. Stellanova
 */ 
public class KDbException extends Exception {
    
    /**
     * These three fields represent three potential error levels
     */
    static final int NONE = 0;
    static final int RECOVERABLE = 1;
    static final int FATAL = 2;

 
    public final int code;
    /**
     * The fault code reported by the XMLRPC server (or internally)
     */
    public int faultCode;
    /**
     * @param code an integer representing the error code
     * @param message a String containing the error message
     */    
    public KDbException(int errCode, String msg) {
	super(msg );
	faultCode = errCode;
        code = errCode;
    }//KDbException
    
}//class KDbException