/* Copyright (c) 2001-2005 Todd C. Stellanova, rawthought
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The  above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE. 
 * 
 *
 * Created on November 6, 2002, 11:48 AM
 */

package org.kablog.kgui;
import java.io.*;
import javax.microedition.lcdui.*;

/**
 * Interface for exporting the progress of a given item
 * @author  Todd C. Stellanova
 */
public class KSplashAlert extends Form 
{
	ImageItem imgItem;
	
    public KSplashAlert(String title, String iconLoc, String msg)
    {
    	super(title);
    	
    	imgItem = null;
    	if (iconLoc != null) {
    		try {
    			Image newImg = Image.createImage(iconLoc);
    			imgItem = new ImageItem(msg,newImg,ImageItem.LAYOUT_CENTER,"Splash");
    			this.append(imgItem);
	    		
    		}
    		catch (IOException ioEx) {
    			System.err.println("bad icon: " + iconLoc);
    		}
    	}
    	
    	
    
    
    }
    
} //class KSplashAlert
