/* Copyright (c) 2001-2005 Todd C. Stellanova, rawthought
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The  above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE. 
 * 
 * 
 * Created on May 26, 2003, 6:35 PM
 */

package org.kablog.midlet2;



import javax.microedition.media.*;
import javax.microedition.media.control.*;

import javax.microedition.lcdui.*;

import org.kablog.kdb.*;
import org.kablog.kgui.*;

import java.util.*;
import java.io.*;


/**
 * This class displays a list of blog entries in the entry cache.
 * The user can select one or more blog entries to post, edit, or delete.
 *
 * @author  Todd C. Stellanova
 *  
 */
public class CameraDisplay extends BaseCamDisplay 
//implements PlayerListener
{
        
    Player  player;
    //Player  soundPlayer;
    VideoControl vc;
    
    protected static final boolean bDebug = false;
    
    protected static final String  locator1 = "capture://video";
    protected static final String  locator2 = "capture://video?encoding=yuv420";
    protected static final String  locator3 = "capture://video?encoding=jpeg";
    protected static final String  locator4 = "capture://video?encoding=jpeg&width=";
    
    protected static final int	nLocators = 4;


	//locator = "capture://video";
	//locator = "capture://video?encoding=yuv420&width=320&height=240";
	//locator = "capture://video?encoding=yuv420&width=" +baseWidth + "&height=" + baseHeight;
	  
//    RecordControl recCtl;
//    ByteArrayOutputStream voutStream;
      
/* 
    public void playerUpdate(javax.microedition.media.Player sourcePlayer, String evtStr, Object evtData) 
    {
         if (sourcePlayer.equals(this.player)) {
            if (evtStr.equals(PlayerListener.RECORD_STARTED)) {
                
            }
            else if (evtStr.equals(PlayerListener.RECORD_STOPPED)) {
                stateBegin_videoCaptured();
            }
            else if (evtStr.equals(PlayerListener.RECORD_ERROR)) {
                
            }
            else {
                viewParent.displayDbgMsg("playerUpdate: " +evtStr , AlertType.INFO);
            }
        }
    }//playerUpdate
*/


    protected byte[] getCameraData(int width, int height) throws MediaException 
    {
        byte[] newData = null;
              
        String availEncodings = System.getProperty("video.snapshot.encodings");
        String formatReq = null;
        String rawEncodingFormat = null;
        String encodingFormat = null;
        
        if (bDebug) System.out.println("availEncodings: " + availEncodings);
        	

		
		if (ENCODING_IMG_UNKNOWN == this.curReqEncoding)
		{
			//JPEG is our preferred format, suckas
			if ( (-1 != availEncodings.indexOf("jpeg")) || (-1 != availEncodings.indexOf("jpg")))
	    			this.curReqEncoding = ENCODING_IMG_JPEG;
		}
		
		switch (this.curReqEncoding)
		{
        
        case (ENCODING_IMG_UNKNOWN):
    	{
    	
	           //figure out which encoding is first in the list
	        int firstPos = availEncodings.indexOf("encoding=");
	        String firstEncoding = "jpeg";
	        
	        if (-1 != firstPos)
	        {
	        	int secondPos = availEncodings.indexOf("encoding=",firstPos+1);
	        	 firstEncoding = availEncodings.substring(firstPos+9,secondPos-1);
	        	if (bDebug) System.out.println("firstEncoding: " + firstEncoding);
	        }
	    		
	    	rawEncodingFormat = firstEncoding;
	    	
	    	if ( (-1 != firstEncoding.indexOf("jpeg")) || (-1 != firstEncoding.indexOf("jpg")))
	    			this.curReqEncoding = ENCODING_IMG_JPEG;
	    	else if (-1 != firstEncoding.indexOf("png"))
		    		this.curReqEncoding = ENCODING_IMG_PNG;
     		else if (-1 != firstEncoding.indexOf("bmp"))
		    		this.curReqEncoding = ENCODING_IMG_BMP;
    	
	    	
    	}
    	break;
    	
        case (ENCODING_IMG_JPEG):
        {
        	if (-1 != availEncodings.indexOf("jpeg"))
        		rawEncodingFormat = "jpeg";
        	else if (-1 != availEncodings.indexOf("jpg"))
        		rawEncodingFormat = "jpg";
        		
         }           
         break;
                     
   		case (ENCODING_IMG_PNG):
   		{
   			rawEncodingFormat = "png";
    	}
    	break;
    	
  		case (ENCODING_IMG_BMP):
   		{
   			rawEncodingFormat = "bmp";
    	}
    	break;
    	
    	}//switch
    	
 
   		
   		
      	encodingFormat = "encoding=" + rawEncodingFormat;
    	formatReq = encodingFormat + 
                        IMG_FORMAT_WIDTH + width +
                        IMG_FORMAT_HEIGHT + height;   

   		if (bDebug) System.out.println("formatReq: " + formatReq);
   			
   		try { newData = vc.getSnapshot(formatReq);}
   		catch (MediaException formatEx)
   		{
   			if (bDebug) System.out.println("retry getSnapshot with: " + encodingFormat);
   			//retry with the  encoding format...
			try {newData = vc.getSnapshot(encodingFormat);}
			catch (MediaException encodingEx)
			{
	   			if (bDebug) System.out.println("retry getSnapshot with: " + rawEncodingFormat);
				newData = vc.getSnapshot(rawEncodingFormat);
			}
   		}

        return newData;
    }

    protected void doRecordPhoto()
    {        
    	if (bDebug) System.out.println("doRecordPhoto...");
			
        try {
            player.stop(); // "pause" the display of video data...
            int thumbWidth = 120, thumbHeight = 90;
            if (encodingWidth < thumbWidth) {
                thumbWidth = encodingWidth;
                thumbHeight = encodingHeight;
            }
             curMediaData = getCameraData(this.encodingWidth, this.encodingHeight);
             curThumbData = getCameraData(thumbWidth,thumbHeight);
             /*
             if (this.soundPlayer != null) 
                 try {
                     soundPlayer.start();
                 }
                 catch (MediaException mediaEx) {
                     viewParent.displayDbgMsg("play sound media ex: " +mediaEx , AlertType.WARNING);
                 }
             */
 
            curMediaName = "img_" + String.valueOf( new Date().getTime()); // + ".jpg"; //simple date hash
            snapShotImage = Image.createImage(this.curMediaData,0,this.curMediaData.length);
            
            if (bDebug) System.out.println("snapShotImage: " + snapShotImage);

         }
        catch (MediaException mediaEx) {
        	if (bDebug) System.out.println(" recordPhoto failed: " + mediaEx);
           viewParent.displayDbgMsg("recordPhoto failed: " + mediaEx , AlertType.ERROR);
        }
        catch (Exception ex)
        {
       		if (bDebug) System.out.println(" recordPhoto failed: " + ex);
        }
        
    }//recordPhoto
 
    /*
    protected void recordVideo()
    {            
        try {
            //register for events!
            player.addPlayerListener(this); 
            
            //wait for PlayerListener callbacks            
            recCtl = (RecordControl)player.getControl("RecordControl");
            voutStream = new ByteArrayOutputStream(128000);
            recCtl.setRecordStream(voutStream);
            recCtl.setRecordSizeLimit(128000);
            recCtl.startRecord();           
         }
        catch (Exception ex) {
            viewParent.displayDbgMsg("recordVideo failed: " + ex , AlertType.ERROR);
         }
        
    }//recordVideo
     **/
    
    
 
 /*
    protected void paint(Graphics gw) {
        
        int clipH, clipW;
        clipH = gw.getClipHeight();
        clipW = gw.getClipWidth();
        
        switch (curState) {
            
            case STATE_IDLE:
                gw.drawString("Idle...",(clipW/2) , (clipH / 2),
                    Graphics.HCENTER|Graphics.VCENTER);
                break;
                
            //case STATE_PHOTO_VIEWFINDER:
              //Don't need to render here, because the camera blits directly to screen!
              //  break;
                
            case STATE_PHOTO_CAPTURED:
                if (this.snapShotImage != null) {
               		gw.drawImage(this.snapShotImage,(clipW/2),(clipH/2),Graphics.HCENTER|Graphics.VCENTER);
  
                   // gw.drawImage(this.snapShotImage,0,0,Graphics.HCENTER|Graphics.TOP);
                }     
                break;
                
            //case STATE_VIDEO_VIEWFINDER:
            //Don't need to render here, because the camera blits directly to screen!
                //break;
 
             case STATE_VIDEO_CAPTURED:
                break;         
        }
        
 
        
    }//paint
    */
    
    
    protected int doera(int baseWidth, int baseHeight) {
        int sourceWidth, sourceHeight, leftX, topY;
        int thisViewWidth, thisViewHeight;
        int retVal = 0;
        
          try {
          	
            String  locator = "";
            
 
			for (int i=nLocators; i > 0 ; i--)
			{

	           this.previewMediaType = "image/jpeg";
			
				switch (i)
				{
					case (4):
					 locator = locator4 + +baseWidth  + "&height=" + baseHeight;
					 break;
					 
					case (3):
	 				locator = locator3;
	 				break;
	 				
	 				case (2):
	 				locator = locator2;
	 				this.previewMediaType =   "image/yuv420";
	 				break;	 				
	 				
	 				case (1):
	 				locator = locator1;
	 				break;
				}
				
	            try { 
	            	if (bDebug) System.out.println("Locator (" + i + "): " + locator);
	            	player = Manager.createPlayer(locator);
	            }
	            catch (Exception ex) {
	                if (bDebug) System.out.println("No love: " + ex);
	                continue; //fail...next freakin locator
	             }
            
            	break; //success-- exit the loop
            }
             
            player.realize();
           if (bDebug) System.out.println("player class: " + player.getClass());
           vc = (VideoControl)player.getControl("VideoControl");
           if (bDebug) System.out.println("VideoControl class: " + vc.getClass());
 
            vc.initDisplayMode(VideoControl.USE_DIRECT_VIDEO, this);
            //vc.initDisplayMode(VideoControl.USE_GUI_PRIMITIVE, this);
            sourceWidth = vc.getSourceWidth();
            sourceHeight = vc.getSourceHeight();
           
            thisViewWidth = this.getWidth();
            thisViewHeight = this.getHeight();
            
            if (sourceWidth > thisViewWidth) {
                //TODO scaling code is kinda broken!
                int scaleFactor;
                scaleFactor = (sourceWidth / thisViewWidth);
                if (scaleFactor == 0) 
                    scaleFactor = 1;
                viewWidth = sourceWidth / scaleFactor;
                viewHeight = sourceHeight / scaleFactor;
                
                //check again...if we're still too big, resize
                if (viewWidth > baseWidth) {
                    viewWidth = thisViewWidth;
                    viewHeight = thisViewHeight;
                }
            }
            else {
                viewWidth = sourceWidth;
                viewHeight = sourceHeight;
            }
            vc.setDisplaySize(viewWidth,viewHeight);
            
            //center the view window, in case it's smaller than the screen
            leftX = (this.getWidth() - viewWidth) / 2;
           topY = (this.getHeight() - viewHeight) / 2;
            vc.setDisplayLocation(leftX, topY);
            
            /*
            String audioProp = System.getProperty("audio.encodings");
            if ((audioProp != null) && (audioProp.indexOf("wav") != -1)) 
                try {
                    InputStream is = this.getClass().getResourceAsStream("res/camsound1.wav");
                    soundPlayer = Manager.createPlayer(is,"audio/x-wav");
                    soundPlayer.realize();
                }
                catch (MediaException mediaEx) {}
             */
                 
          }
       //  catch (IOException ioEx) {
       //    viewParent.displayDbgMsg("initCamera ioEx: " + ioEx , AlertType.ERROR);
       // }
        catch (MediaException mediaEx) {
         	if (bDebug) System.out.println("initCamera mediaEx: " + mediaEx);
          viewParent.displayDbgMsg("initCamera mediaEx: " + mediaEx , AlertType.ERROR);
        }
        catch (Exception ex) {
        	if (bDebug) System.out.println("initCamera ex: " + ex);
           viewParent.displayDbgMsg("initCamera ex: " + ex , AlertType.ERROR);        
        }
   
        return retVal;
    }//initCamera
    
   protected void startCameraDisplay()
   {
      try {
          vc.setVisible(true);
          player.start();        
       }
       catch (MediaException mediaEx) {
       		if (bDebug) System.out.println("startCameraDisplay mediaEx: " + mediaEx);
            viewParent.displayDbgMsg("startCameraDisplay mediaEx: " + mediaEx , AlertType.ERROR);
      }
   }//startCameraDisplay

      
      /***
      * All the state transition methods follow.
     */

     
     /**
      * We've captured a video...now we can display or save it.
      */
   /*
     protected void stateBegin_videoCaptured()
     {
        player.removePlayerListener(this);   
        super.stateBegin_videoCaptured();
      }
    **/
     
     public void doCleanup() {
        if (vc != null) {
            vc.setVisible(false);
            vc = null;
        }
        
        if (player != null) {
             player.close();
            player = null;
        }
        
        /*
       if (soundPlayer != null) {
                soundPlayer.close();
            soundPlayer = null;
       } 
       */    
    }
       
     
     protected void doDisplayViewFinder() {
         startCameraDisplay();
     }
     
      protected void doSetImageSize(int w, int h)
      {
          int newWidth, newHeight;
          super.doSetImageSize(w,h);
          
          if (vc != null) 
            try {
                player.stop();
                vc.setVisible(false);             
                if (w < viewWidth) {
                    newWidth = w; 
                    newHeight = h;
                }
                else {
                    newWidth = viewWidth; 
                    newHeight = viewHeight;                
                }             

                vc.setDisplaySize(newWidth,newWidth);
                //center the view window, in case it's smaller than the screen
                int leftX = (this.getWidth() - newWidth) / 2;
                int topY = (this.getHeight() - newHeight) / 2;
                vc.setDisplayLocation(leftX, topY);

                vc.setVisible(true);
                player.start(); //restart player
            }
            catch (MediaException mediaEx) {
            
            	if (bDebug) System.out.println("player/vc ex: " + mediaEx);
            }
             
   
      }//doSetImageSize
 
         
      public Image getThumbnail(int width, int height) {
          Image thumbImg = snapShotImage;
          
          
          return thumbImg;
        }
   
}//class CameraDisplay
