
/* Copyright (c) 2001-2005 Todd C. Stellanova, rawthought
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The  above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE. 
 * 
 * Created on November 7, 2002, 4:03 PM
 */

package org.kablog.midlet2;
import org.kablog.kdb.*;


/**
 *
 * @author  Todd C. Stellanova
 */
public class EntriesDB extends KDbAccessor {
    
     public final static String DB_STORENAME = "blogEntries";
     
     /**
     * Static sole means to get Accessor
     */
    public static EntriesDB getDB() {
     if (dbCache == null) {
         dbCache = new EntriesDB();
         dbCache.storeName = DB_STORENAME;
     }      
     return (EntriesDB)dbCache;
    }//getDB
    
    /**
     * @return an empty EntryRecord
     */
    public EntryRecord getBlankEntry() {
        return (EntryRecord)createBlankRecord();
    }//getBlankEntry
    
    
    /**
     * Use only after beginning a search
     */
    public EntryRecord getNextEntry() throws KDbException {
        EntryRecord rec = (EntryRecord)this.getNextRecord();
        return rec;
    }//getNextEntry
    
     /** 
      * Create a template blank record.
     */
    protected KDbRecord createBlankRecord() {
        EntryRecord curRec = new EntryRecord();
        return curRec;
    }//createBlankRecord    
    
}//class EntriesDB
