
/* Copyright (c) 2001-2005 Todd C. Stellanova, rawthought
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The  above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE. 
 * 
 * 
 * Created on October 31, 2002, 12:16 PM
 */
package org.kablog.midlet2;


import javax.microedition.lcdui.*;

import org.kablog.kgui.*;

import java.util.*;
import java.io.*;
/**
 *
 * @author  Todd C. Stellanova
 */

public class HostSetupForm extends SetupFormBase  {
    
    //KEEP THESE IN ORDER
    protected static final String MI_SERVER_TYPE_MOVTYP = "TypePad/MovableType";
    protected static final String MI_SERVER_TYPE_MWEBLOG = "metaWeblog";
    protected static final String MI_SERVER_TYPE_BLOGGER = "Blogger";
    
    private TextField    hostURLInput;
    private ChoiceGroup  blogTypesChoice;
    private TextField    blogIDInput;

    public HostSetupForm(KablogMIDlet myParent) {
     super("Blog Host Setup",myParent);      
    }//constructor
    
    public void addFormItems(KablogPrefs prefs) {
        String blogTypesList[] = {MI_SERVER_TYPE_MOVTYP,MI_SERVER_TYPE_MWEBLOG,MI_SERVER_TYPE_BLOGGER};
        
     hostURLInput = new TextField("Full URL:", prefs.sURL, 256, TextField.ANY);    
     this.append(hostURLInput);
     
    blogTypesChoice = new ChoiceGroup("Blog Type:", ChoiceGroup.EXCLUSIVE,
        blogTypesList , null);
    
    blogTypesChoice.setSelectedIndex(prefs.nBlogServerType,true);
     this.append(blogTypesChoice);
    
     String sInitialBlogID = prefs.sCurBlogID;
     
    blogIDInput = new TextField("Blog ID (optional):", sInitialBlogID, 16, TextField.ANY);
     this.append(blogIDInput);
    
     
    }//addFormItems
    
    public void collectFormData(KablogPrefs prefs) {
        prefs.sURL = hostURLInput.getString();
        prefs.nBlogServerType = blogTypesChoice.getSelectedIndex();
        prefs.bHostInfoEdited = true;
        
        String sBlogID;
        if (( (sBlogID = blogIDInput.getString()) != null)&&
            (sBlogID.length() > 0) ) 
        {
            prefs.bBlogSelected = true;
            prefs.sCurBlogID = sBlogID;
        }
    }
    
//CommandAction
    
}//class UserSetupForm

