/* Copyright (c) 2001-2005 Todd C. Stellanova, rawthought
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The  above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE. 
 * 
 * Created on November 4, 2002, 5:16 PM
 */

package org.kablog.midlet2;


import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

import java.util.*;

/**
 *
 * @author  Todd C. Stellanova
 * @version
 */
public class MainMenu extends List  implements CommandListener{
    
    protected final static String MI_SETUPUSER = "Setup User";
    protected final static String MI_SETUPHOST = "Setup Host";
    protected final static String MI_SELECTBLOG = "Select Blog";
    protected final static String MI_NEW_ADV_ENTRY = "New Entry";
    protected final static String MI_VIEW_CACHE = "View Cache";
   // protected final static String MI_REGISTER = "--Please Register--";
   // protected final static String MI_MUST_REGISTER = "--Demo Expired: Register--";
    protected final static String MI_TAKE_SNAPSHOT = "Take Snapshot";
    protected final static String MI_RECORD_SOUND = "Record Sound";
    protected final static String MI_TEST_PROFILE = "Test Profile";
    
    
    protected final static boolean debugOn = false;
    
    protected Command cmd_Exit;
    
    protected KablogPrefsDB prefsDB;
    protected KablogMIDlet parent;
    
    public MainMenu(KablogMIDlet myParent) {
       super("Main Menu",Choice.IMPLICIT);
       parent = myParent;
       prefsDB = KablogPrefsDB.getDB();

       setupMenuItems();
       cmd_Exit = new Command("Exit",Command.EXIT,2);
       this.addCommand(cmd_Exit);
       setCommandListener(this);
       
    }//MainMenu
    
    
    /**
     *
     */
    protected void setupMenuItems() {
                   
        if (prefsDB.prefsExist()) {
           KablogPrefs prefs = prefsDB.getKablogPrefsRecord();
 
          if (prefs.bBlogSelected) {
                //we only start checking for reg info after the user
                //has successfully set up their prefs and
                //downloaded and selected a blog to use
                /*
                if (RegMgr.checkShowReg(prefs)) {
                	
                	
                    if (prefs.bDemoExpired) {
                    	append( MI_MUST_REGISTER, null);
                        return; //we don't allow any other options, really
                    }
                    else
                   	 append( MI_REGISTER, null);
                    
                }
                else {
                */
                    EntriesDB entriesDB = EntriesDB.getDB();
                    if (entriesDB.getEntryCount() > 0)
                        append( MI_VIEW_CACHE, null);

                    append( MI_NEW_ADV_ENTRY, null);
                    //even though we've already configured user and so forth, 
                    //allow the user to change these settings
                    append( MI_SELECTBLOG, null);
                    append( MI_SETUPHOST, null);
                    append( MI_SETUPUSER, null);
                    
                    /*
                    if (!prefs.bRespReceived) {
                        int maxIdx = this.size(); //how many elements have we added?
                        if (maxIdx > 0) {
                            Random randSrc = new Random();
                            int location;
                            do {location = randSrc.nextInt();}
                            while (location < 0);
                            
                            location = location % maxIdx;
                            //System.out.println("### inserting at " +location);
                            insert(location,MI_REGISTER,null);
                        }
                    }
                    */
                //}
           }
           else if (prefs.bHostInfoEdited) {
            append( MI_SELECTBLOG, null);
            append( MI_SETUPHOST, null);
            append( MI_SETUPUSER, null);
           }
           else if (prefs.bUserInfoEdited) {
            append( MI_SETUPHOST, null);
            append( MI_SETUPUSER, null);               
           }
           else {
            append( MI_SETUPUSER, null);               
           }     
        }
        else {
          append( MI_SETUPUSER, null);   
        }
        
       if (debugOn)
       	 append(MI_TEST_PROFILE,null);
 
  
     
    }//setupMenuItems
    
     public void commandAction(Command c, Displayable s) {
        if (c == List.SELECT_COMMAND) {
           int selectedIdx = getSelectedIndex();
           String itemStr = getString(selectedIdx);
           if (itemStr != null) {
               
               if (itemStr.equals(MI_SETUPUSER)) {
                   parent.doUserPrefsEdit();
               }
               else if (itemStr.equals(MI_SETUPHOST)) {
                   parent.doHostPrefsEdit();
               }
               else if (itemStr.equals(MI_SELECTBLOG)) {
                   parent.doTargetBlogSelect();
               }
               else if (itemStr.equals(MI_NEW_ADV_ENTRY)) {
                    parent.doLaunchAdvEditor();
               }  
               else if (itemStr.equals(MI_VIEW_CACHE)) {
                   parent.doLaunchCacheViewer();
               }
               //else if (itemStr.equals(MI_REGISTER)) {
               //    parent.doRegister();
               //}
               //else if (itemStr.equals(MI_MUST_REGISTER)) {
               //		parent.doRegister();
               //}
               else if (itemStr.equals(MI_TEST_PROFILE)) {
                   parent.doProfileTest();
               }
               else {
                   //if (debugOn) System.out.println("unhandled MI: " +itemStr);
               }
               //now unused
               prefsDB = null;
           }
        }
        else if ( c== cmd_Exit) {
            parent.doExitApp();
        }
        else {
            //if (debugOn) System.out.println("MainMenu unhandled cmd: " +c );
        }
     }//commandAction
}//class MainMenu 
